Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1144)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1145)
@@ -4139,50 +4416,66 @@
 	const long startTime = GetTime();	
 	
-	int i = 0;
+	RunConstruction(true);
+
+	cout << "finished in " << TimeDiff(startTime, GetTime())*1e-3 << " secs" << endl;
+
+	mVspTree.mVspStats.Stop();
+}
+
+
+bool HierarchyManager::SubdivideSplitCandidate(SplitCandidate *sc)
+{
+	const bool globalTerminationCriteriaMet = 
+			GlobalTerminationCriteriaMet(sc);
+
+	const bool vspSplit = (sc->Type() == SplitCandidate::VIEW_SPACE);
+
+	if (vspSplit)
+	{
+		mVspTree.Subdivide(mTQueue, sc, globalTerminationCriteriaMet);
+		return true;
+	}
+	else
+	{
+		mOspTree.Subdivide(mTQueue, sc, globalTerminationCriteriaMet);
+		return false;
+	}
+}
+
+
+void HierarchyManager::RunConstruction(const bool repair)
+{
+	int numNodes = 0;
+
 	while (!FinishedConstruction())
 	{
-		mCurrentCandidate = NextSplitCandidate();
-	   
-		const bool globalTerminationCriteriaMet = 
-			GlobalTerminationCriteriaMet(mCurrentCandidate);
-
-		cout << "view cells: " << i ++ << endl;
-
+		SplitCandidate *splitCandidate = NextSplitCandidate();
+	    
+		cout << "nodes: " << ++ numNodes << endl;
+
+		mTotalCost -= splitCandidate->GetRenderCostDecrease();
+
+		//-- subdivide leaf node
+		SubdivideSplitCandidate(splitCandidate);
+		
 		// cost ratio of cost decrease / totalCost
-		const float costRatio = mCurrentCandidate->GetPriority() / mTotalCost;
-		//Debug << "cost ratio: " << costRatio << endl;
+		const float costRatio = splitCandidate->GetRenderCostDecrease() / mTotalCost;
+		
+		Debug << "\n**********" << endl
+			  << "total cost: " << mTotalCost << " render cost decr: " 
+			  << splitCandidate->GetRenderCostDecrease() 
+			  << " cost ratio: " << costRatio << endl << endl;
 
 		if (costRatio < mTermMinGlobalCostRatio)
 			++ mGlobalCostMisses;
-
-		//-- subdivide leaf node
-
-		// we have either a object space or view space split
-		if (mCurrentCandidate->Type() == SplitCandidate::VIEW_SPACE)
-		{
-			VspTree::VspSplitCandidate *sc = 
-				dynamic_cast<VspTree::VspSplitCandidate *>(mCurrentCandidate);
-
-			VspNode *r = mVspTree.Subdivide(mTQueue, *sc, globalTerminationCriteriaMet);
-		}
-		else // object space split
-		{			
-			OspTree::OspSplitCandidate *sc = 
-				dynamic_cast<OspTree::OspSplitCandidate *>(mCurrentCandidate);
-
-			KdNode *r = mOspTree.Subdivide(mTQueue, *sc, globalTerminationCriteriaMet);
-		}
 
 		// reevaluate candidates affected by the split
 		// for view space splits, this would be object space splits
 		// and other way round
-		RepairQueue();
-
-		DEL_PTR(mCurrentCandidate);
-	}
-
-	cout << "finished in " << TimeDiff(startTime, GetTime())*1e-3 << " secs" << endl;
-
-	mVspTree.mVspStats.Stop();
+		if (repair)
+			RepairQueue();
+
+		DEL_PTR(splitCandidate);
+	}
 }
 
@@ -4195,7 +4488,9 @@
 	RayInfoContainer *objectSpaceRays = new RayInfoContainer();
 
+
 	/////////////////////////////////////////////////////////////
 	// view space space partition
 	/////////////////////////////////////////////////////////////
+
 
 	// makes no sense otherwise because only one kd cell available
@@ -4207,6 +4502,8 @@
 	mVspTree.mStoreKdPvs = false;
 
-	SplitCandidate *sc = PrepareVsp(sampleRays, forcedViewSpace, *viewSpaceRays);
-	mTQueue.Push(sc);
+	VspTree::VspSplitCandidate *vsc = 
+		PrepareVsp(sampleRays, forcedViewSpace, *viewSpaceRays);
+	// add to queue
+	mTQueue.Push(vsc);
 
 	long startTime = GetTime();
@@ -4218,81 +4515,50 @@
 	int i = 0;
 
-	while (!FinishedConstruction())
-	{
-		SplitCandidate *splitCandidate = NextSplitCandidate();
-	    
-		const bool globalTerminationCriteriaMet = 
-			GlobalTerminationCriteriaMet(splitCandidate);
-
-		cout << "vsp nodes: " << i ++ << endl;
-
-		// cost ratio of cost decrease / totalCost
-		const float costRatio = splitCandidate->GetPriority() / mTotalCost;
-		//cout << "cost ratio: " << costRatio << endl;
-
-		if (costRatio < mTermMinGlobalCostRatio)
-			++ mGlobalCostMisses;
-
-		//-- subdivide leaf node
-
-		// we have either a object space or view space split
-		VspTree::VspSplitCandidate *sc = 
-			dynamic_cast<VspTree::VspSplitCandidate *>(splitCandidate);
-
-	
-		VspNode *r = mVspTree.Subdivide(mTQueue, *sc, globalTerminationCriteriaMet);
-
-		DEL_PTR(splitCandidate);
-	}
+	// all objects can be seen from everywhere
+	mTotalCost = (float)vsc->mParentData.mPvs;
+
+	const bool repairQueue = false;
+
+	// process view space candidates
+	RunConstruction(repairQueue);
 
 	cout << "finished in " << TimeDiff(startTime, GetTime())*1e-3 << " secs" << endl;
 	mVspTree.mVspStats.Stop();
 	
-	
+
+
 	/////////////////////////////////////////////////////////////
 	// object space partition
 	/////////////////////////////////////////////////////////////
 
-	Debug << "**************** osp construction **************" << endl;
+	Debug << "\n$$$$$$$$$ osp tree construction $$$$$$$$$$\n" << endl;
 	cout << "starting osp contruction ... " << endl;
 
+	// compute first candidate
+	OspTree::OspSplitCandidate *osc =
+		PrepareOsp(sampleRays, objects, forcedViewSpace, *objectSpaceRays);
+
+    mTQueue.Push(osc);
+
+	mOspTree.mOspStats.Reset();
+	mOspTree.mOspStats.Start();
+
 	startTime = GetTime();
 
-	SplitCandidate *osc =
-		PrepareOsp(sampleRays, objects, forcedViewSpace, *objectSpaceRays);
-
-    mTQueue.Push(osc);
-
-
-	i = 0;
-	while (!FinishedConstruction())
-	{
-		SplitCandidate *splitCandidate = NextSplitCandidate();
-	    
-		const bool globalTerminationCriteriaMet = 
-			GlobalTerminationCriteriaMet(splitCandidate);
-
-		// cost ratio of cost decrease / totalCost
-		const float costRatio = splitCandidate->GetPriority() / mTotalCost;
-		
-		//Debug << "cost ratio: " << costRatio << endl;
-		//cout << "kd nodes: " << i ++ << endl;
-
-		if (costRatio < mTermMinGlobalCostRatio)
-			++ mGlobalCostMisses;
-
-		//-- subdivide leaf node
-
-		// object space split
-		OspTree::OspSplitCandidate *sc = 
-			dynamic_cast<OspTree::OspSplitCandidate *>(splitCandidate);
-
-		KdNode *r = mOspTree.Subdivide(mTQueue, *sc, globalTerminationCriteriaMet);
-		
-		DEL_PTR(splitCandidate);
-	}
-	
-	cout << "finished in " << TimeDiff(startTime, GetTime())*1e-3 << " secs" << endl;
-
+	// reset cost
+	// start with one big kd cell - all objects can be seen from everywhere
+	// note: only true for view space = object space
+	mTotalCost = (float)osc->mParentData.mNode->mObjects.size();//(float)sc->mParentData.mPvs;
+
+	Debug << "reseting cost, new total cost: " << mTotalCost << endl;
+
+	// process object space candidates
+	RunConstruction(repairQueue);
+	
+	cout << "finished in " << TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl;
+
+	mOspTree.mOspStats.Stop();
+
+	// reset parameters
 	mVspTree.mUseKdPvsForHeuristics = savedCountMethod;
 	mVspTree.mStoreKdPvs = savedStoreMethod;
@@ -4304,4 +4570,7 @@
 								  AxisAlignedBox3 *forcedViewSpace)
 {
+	// only view space partition
+	// object kd tree is taken for osp
+
 	mVspTree.mVspStats.Reset();
 	mVspTree.mVspStats.Start();
@@ -4315,33 +4584,6 @@
 
 	long startTime = GetTime();
-	int i = 0;
-
-	while (!FinishedConstruction())
-	{
-		SplitCandidate *splitCandidate = NextSplitCandidate();
-	    
-		const bool globalTerminationCriteriaMet = 
-			GlobalTerminationCriteriaMet(splitCandidate);
-
-		cout << "vsp nodes: " << i ++ << endl;
-		
-		// cost ratio of cost decrease / totalCost
-		const float costRatio = splitCandidate->GetPriority() / mTotalCost;
-		//cout << "cost ratio: " << costRatio << endl;
-
-		if (costRatio < mTermMinGlobalCostRatio)
-			++ mGlobalCostMisses;
-
-		//-- subdivide leaf node
-	
-		// we have either a object space or view space split
-		VspTree::VspSplitCandidate *sc = 
-			dynamic_cast<VspTree::VspSplitCandidate *>(splitCandidate);
-
-	
-		VspNode *r = mVspTree.Subdivide(mTQueue, *sc, globalTerminationCriteriaMet);
-
-		DEL_PTR(splitCandidate);
-	}
+
+	RunConstruction(false);
 
 	cout << "finished in " << TimeDiff(startTime, GetTime())*1e-3 << " secs" << endl;
@@ -4350,5 +4592,5 @@
 
 
-bool HierarchyManager::FinishedConstruction()
+bool HierarchyManager::FinishedConstruction() const
 {
 	return mTQueue.Empty();
Index: GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.cpp	(revision 878)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.cpp	(revision 1145)
@@ -1,4 +1,3 @@
-#include <QApplication>
-
+//#include <QApplication>
 #include "PreprocessorThread.h"
 #include "Camera.h"
@@ -11,50 +10,62 @@
 
 
+// matt: remove qt dependencies
+/*
 PreprocessorThread::PreprocessorThread(Preprocessor *p,
 									   QObject *parent):QThread(parent)
 {
   mPreprocessor = p;
+  
   if (p->mQuitOnFinish)
 	connect(this, SIGNAL(finished()), qApp, SLOT(closeAllWindows(void)));
 }
+*/
 
-void
-PreprocessorThread::Main()
+PreprocessorThread::PreprocessorThread(Preprocessor *p):
+mPreprocessor(p)
 {
-  
-  Camera camera;
-
-  if (0) {
-	// camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
-	 //	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
-	camera.SetPosition(Vector3(3473, 6.778, -1699));
-	camera.SetDirection(Vector3(-0.2432, 0, 0.97));
-	//	camera.SetPosition(Vector3(991.7, 187.8, -271));
-	//	camera.SetDirection(Vector3(0.9, 0, -0.4));
-
-    camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  } 
-
-  if (0) {
-    camera.LookInBox(mPreprocessor->mKdTree->GetBox());
-    camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
-    camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  }
-
-  if (0) {
-    camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
-	camera.SetDirection(Vector3(1, 0, 0));
-	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  }
-
-  if (mPreprocessor->mComputeVisibility) {
-    mPreprocessor->ComputeVisibility();
-	//	mPreprocessor->ExportPreprocessedData("scene.vis");
-	mPreprocessor->PostProcessVisibility();
-  }
-  
+}
 
 
-  cerr << "Preprocessor main finished...\n";
+void PreprocessorThread::operator()()
+{
+	Main();
+}
+
+void PreprocessorThread::Main()
+{
+	Camera camera;
+
+	if (0) 
+	{
+		// camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
+		//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
+		camera.SetPosition(Vector3(3473, 6.778, -1699));
+		camera.SetDirection(Vector3(-0.2432, 0, 0.97));
+		//	camera.SetPosition(Vector3(991.7, 187.8, -271));
+		//	camera.SetDirection(Vector3(0.9, 0, -0.4));
+
+		camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+	} 
+
+	if (0) {
+		camera.LookInBox(mPreprocessor->mKdTree->GetBox());
+		camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
+		camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+	}
+
+	if (0) {
+		camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
+		camera.SetDirection(Vector3(1, 0, 0));
+		camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+	}
+
+	if (mPreprocessor->mComputeVisibility) {
+		mPreprocessor->ComputeVisibility();
+		//	mPreprocessor->ExportPreprocessedData("scene.vis");
+		mPreprocessor->PostProcessVisibility();
+	}
+
+	cerr << "Preprocessor main finished...\n";
   
 }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1144)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1145)
@@ -53,5 +53,6 @@
 mMinPvsSize(0), // one means only empty view cells are invalid
 mMaxPvsRatio(1.0),
-mViewCellPvsIsUpdated(false)
+mViewCellPvsIsUpdated(false),
+mPreprocessor(NULL)
 {
 	mViewSpaceBox.Initialize();
@@ -343,10 +344,10 @@
 	SimpleRayContainer simpleRays;
 
-	preprocessor->GenerateRays(samplesPerPass,
+	mPreprocessor->GenerateRays(samplesPerPass,
 							   sampleType,
 							   simpleRays);
 
 	// shoot simple ray and add it to importance samples
-	preprocessor->CastRays(simpleRays, passSamples);
+	mPreprocessor->CastRays(simpleRays, passSamples);
 
 	return (int)passSamples.size();
@@ -390,4 +391,6 @@
 int ViewCellsManager::Construct(Preprocessor *preprocessor, VssRayContainer *outRays)
 {
+	mPreprocessor = preprocessor;
+
 	int numSamples = 0;
 
@@ -544,5 +547,5 @@
 	if (mEvaluateViewCells)
 	{
-		EvalViewCellPartition(preprocessor);
+		EvalViewCellPartition();
 	}
 
@@ -597,5 +600,5 @@
 	int histoMaxVal;
 	Environment::GetSingleton()->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
-	maxRenderCost = max(histoMaxVal, maxRenderCost);
+	maxRenderCost = max((float)histoMaxVal, maxRenderCost);
 
 	
@@ -872,5 +875,5 @@
 
 
-void ViewCellsManager::EvalViewCellPartition(Preprocessor *preprocessor)
+void ViewCellsManager::EvalViewCellPartition()
 {
 	int samplesPerPass;
@@ -895,6 +898,5 @@
 	cout << "reseting pvs ... ";
 		
-
-	bool startFromZero = true;
+	const bool startFromZero = true;
 
 	// reset pvs and start over from zero
@@ -903,6 +905,7 @@
 		mViewCellsTree->ResetPvs();
 	}
-	else // statistics without addidtional samples
-	{
+	else // start from current sampless
+	{
+		// statistics before casting more samples
 		cout << "compute new statistics ... ";
 		sprintf(s, "-%09d-eval.log", castSamples);
@@ -1015,10 +1018,4 @@
 		}
 	}
-
-	// find empty view cells bug
-	if (TEST_EMPTY_VIEW_CELLS)
-	{
-		TestEmptyViewCells(preprocessor->mObjects);
-	}
 }
 
@@ -1030,5 +1027,5 @@
 
 
-// Returns index of the best view cells of the neighborhood
+/// Returns index of the best view cells of the neighborhood
 int GetBestViewCellIdx(ViewCell *root, const ViewCellContainer &neighborhood)
 {
@@ -1070,5 +1067,5 @@
 	
 	case PER_TRIANGLE:
-		{cout << "pertriangle" << endl;
+		{//cout << "pertriangle" << endl;
 			// HACK
 			MeshInstance *mi = dynamic_cast<MeshInstance *>(obj);
@@ -1077,5 +1074,5 @@
 			if (mi->GetMesh())
 			{
-				return mi->GetMesh()->mFaces.size();
+				return (float)mi->GetMesh()->mFaces.size();
 			}
 		}
@@ -1292,6 +1289,6 @@
 	sort(mViewCells.begin(), mViewCells.end(), ViewCell::SmallerPvs);
 
-	int start = mViewCells.size()*minValid;
-	int end = mViewCells.size()*maxValid;
+	int start = mViewCells.size() * minValid;
+	int end = mViewCells.size() * maxValid;
 
 	for (int i = 0; i < mViewCells.size(); ++ i)
@@ -1957,5 +1954,5 @@
 float ViewCellsManager::GetRendercost(ViewCell *viewCell) const
 {
-	return mViewCellsTree->GetPvsSize(viewCell);
+	return (float)mViewCellsTree->GetPvsSize(viewCell);
 }
 
@@ -2449,7 +2446,7 @@
 
 
-/**********************************************************************/
-/*                 BspViewCellsManager implementation                 */
-/**********************************************************************/
+/*******************************************************************/
+/*               BspViewCellsManager implementation                */
+/*******************************************************************/
 
 
@@ -4578,12 +4575,12 @@
 	vector<RenderCostSample> samples;
   
-	if (!preprocessor->GetRenderer())
+	if (!mPreprocessor->GetRenderer())
 		return;
 
-	//start the from point queries
+	//start the view point queries
 	long startTime = GetTime();
 	cout << "starting sampling of render cost ... ";
 	
-	preprocessor->GetRenderer()->SampleRenderCost(numSamples, samples, true);
+	mPreprocessor->GetRenderer()->SampleRenderCost(numSamples, samples, true);
 
 	cout << "finished in " << TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl;
@@ -4916,4 +4913,5 @@
 	// print subdivision statistics
 	Debug << mVspTree->GetStatistics() << endl;
+	Debug << mOspTree->GetStatistics() << endl;
 
 	// print view cell statistics
@@ -5333,7 +5331,10 @@
 	
 			const int savedColorCode = mColorCode;
+			mColorCode = 0;
 			const int maxPvs = 200;//mOspTree.GetStatistics().maxPvs;
 
 			exporter->ExportOspTree(*mOspTree, mColorCode == 0 ? 0 : maxPvs);
+
+			mColorCode = savedColorCode;
 
 			delete exporter;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1141)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.cpp	(revision 1145)
@@ -23,16 +23,13 @@
 namespace GtpVisibilityPreprocessor {
 
-static CGcontext sCgContext = NULL;
-static CGprogram sCgFragmentProgram = NULL;
-static CGprofile sCgFragmentProfile;
-
+
+/*
 GLuint frontDepthMap;
 GLuint backDepthMap;
 
 const int depthMapSize = 512;
-static vector<OcclusionQuery *> sQueries;
-
-GlRendererWidget *rendererWidget = NULL;
-GlDebuggerWidget *debuggerWidget = NULL;
+
+//static vector<OcclusionQuery *> sQueries;
+*/
 
 static bool arbQuerySupport = false;
@@ -101,20 +98,11 @@
 {
   cerr<<"gl renderer destructor..\n";
-  if (sCgFragmentProgram)
-	cgDestroyProgram(sCgFragmentProgram);
-  if (sCgContext)
-	cgDestroyContext(sCgContext);
+ 
+  //CLEAR_CONTAINER(sQueries);
+  CLEAR_CONTAINER(mOcclusionQueries);
+
   cerr<<"done."<<endl;
-   
-  CLEAR_CONTAINER(sQueries);
-  CLEAR_CONTAINER(mOcclusionQueries);
-}
-
-
-static void handleCgError() 
-{
-    Debug << "Cg error: " << cgGetErrorString(cgGetError()) << endl;
-    exit(1);
-}
+}
+
 
 void
@@ -264,5 +252,4 @@
   glEnable(GL_CULL_FACE);
   
-  // HACK!! but using glew keeps crashing for some reason ...
   InitExtensions();
   
@@ -328,128 +315,4 @@
 }
 
-void
-GlRendererWidget::RenderInfo()
-{
-  QString s;
-  int vc = 0;
-  if (mViewCellsManager)
-	vc = mViewCellsManager->GetViewCells().size();
-  int filter = 0;
-  if (mViewCellsManager)
-	filter = mViewCellsManager->GetMaxFilterSize();
-
-  s.sprintf("frame:%04d viewpoint:(%4.1f,%4.1f,%4.1f) dir:(%4.1f,%4.1f,%4.1f) viewcells:%04d filter:%04d pvs:%04d error:%5.5f\%",
-			mFrame,
-			mViewPoint.x,
-			mViewPoint.y,
-			mViewPoint.z,
-			mViewDirection.x,
-			mViewDirection.y,
-			mViewDirection.z,
-			vc,
-
-			filter,
-			mPvsSize,
-			mRenderError*100.0f
-			);
-  
-  glColor3f(0.0f,0.0f,0.0f);
-  renderText(0,20,s);
-  
-  if (mShowRenderCost) {
-	static vector<float> costFunction;
-	static float maxCost = -1;
-	if (costFunction.size()==0) {
-	  ViewCellsTree *tree = mViewCellsManager->GetViewCellsTree();
-	  if (tree) {
-		tree->GetCostFunction(costFunction);
-		maxCost = -1;
-		for (int i=0;  i < costFunction.size(); i++) {
-		  //		  cout<<i<<":"<<costFunction[i]<<" ";
-		  if (costFunction[i] > maxCost)
-			maxCost = costFunction[i];
-		}
-	  }
-	}
-
-	
-	int currentPos = mViewCellsManager->GetViewCells().size();
-	float currentCost=-1;
-
-	if (currentPos < costFunction.size())
-	  currentCost = costFunction[currentPos];
-#if 0	
-	cout<<"costFunction.size()="<<costFunction.size()<<endl;
-	cout<<"CP="<<currentPos<<endl;
-	cout<<"MC="<<maxCost<<endl;
-	cout<<"CC="<<currentCost<<endl;
-#endif
-	if (costFunction.size()) {
-	  glDisable(GL_DEPTH_TEST);
-	  // init ortographic projection
-	  glMatrixMode(GL_PROJECTION);
-	  glPushMatrix();
-	  
-	  glLoadIdentity();
-	  gluOrtho2D(0, 1.0f, 0, 1.0f);
-	  
-	  glTranslatef(0.1f, 0.1f, 0.0f);
-	  glScalef(0.8f, 0.8f, 1.0f);
-	  glMatrixMode(GL_MODELVIEW);
-	  glLoadIdentity();
-	  
-	  glColor3f(1.0f,0,0);
-	  glBegin(GL_LINE_STRIP);
-	  //	  glVertex3f(0,0,0);
-	  
-	  for (int i=0;  i < costFunction.size(); i++) {
-		float x =  i/(float)costFunction.size();
-		float y = costFunction[i]/(maxCost*0.5f);
-		glVertex3f(x,y,0.0f);
-	  }
-	  glEnd();
-	  
-	  glColor3f(1.0f,0,0);
-	  glBegin(GL_LINES);
-	  float x =  currentPos/(float)costFunction.size();
-	  glVertex3f(x,0.0,0.0f);
-	  glVertex3f(x,1.0f,0.0f);
-	  glEnd();
-	  
-	  glColor3f(0.0f,0,0);
-	  // show a grid
-	  glBegin(GL_LINE_LOOP);
-	  glVertex3f(0,0,0.0f);
-	  glVertex3f(1,0,0.0f);
-	  glVertex3f(1,1,0.0f);
-	  glVertex3f(0,1,0.0f);
-	  glEnd();
-
-	  glBegin(GL_LINES);
-	  for (int i=0;  i < 50000 && i < costFunction.size(); i+=10000) {
-		float x =  i/(float)costFunction.size();
-		glVertex3f(x,0.0,0.0f);
-		glVertex3f(x,1.0f,0.0f);
-	  }
-
-	  for (int i=0;  i < maxCost; i+=100) {
-		float y = i/(maxCost*0.5f);
-		glVertex3f(0,y,0.0f);
-		glVertex3f(1,y,0.0f);
-	  }
-
-	  glEnd();
-
-	  
-	  // restore the projection matrix
-	  glMatrixMode(GL_PROJECTION);
-	  glPopMatrix();
-	  glMatrixMode(GL_MODELVIEW);
-	  glEnable(GL_DEPTH_TEST);
-
-	}
-  }
-}
-
 
 void
@@ -477,4 +340,32 @@
 			target.x, target.y, target.z,
 			up.x, up.y, up.z);
+}
+
+void
+GlRenderer::_RenderScene()
+{
+  ObjectContainer::const_iterator oi = mObjects.begin();
+
+  for (; oi != mObjects.end(); oi++)
+	RenderIntersectable(*oi);
+}
+
+bool
+GlRenderer::RenderScene()
+{
+  static int glList = -1;
+  if (mUseGlLists) {
+	if (glList == -1) {
+	  glList = glGenLists(1);
+	  glNewList(glList, GL_COMPILE);
+	  _RenderScene();
+	  glEndList();
+	}
+	glCallList(glList);
+  } else
+	_RenderScene();
+	
+  
+  return true;
 }
 
@@ -507,5 +398,23 @@
 }
 
-//std::ofstream outfile("try_arb.txt");
+
+
+/****************************************************************/
+/*               GlRendererBuffer implementation                */
+/****************************************************************/
+
+
+
+GlRendererBuffer::GlRendererBuffer(SceneGraph *sceneGraph,
+								   ViewCellsManager *viewcells,
+								   KdTree *tree):
+GlRenderer(sceneGraph, viewcells, tree)  
+{
+	mPixelBuffer = NULL;
+
+	// implement width and height in subclasses
+}
+
+
 void
 GlRendererBuffer::EvalQueryWithOcclusionQueries(
@@ -604,138 +513,4 @@
 
 void
-GlRendererBuffer::EvalRenderCostSample(RenderCostSample &sample,
-									   const bool useOcclusionQueries,
-									   const int threshold
-									   )
-{
-	// choose a random view point
-	mViewCellsManager->GetViewPoint(mViewPoint);
-	sample.mPosition = mViewPoint;
-	//cout << "viewpoint: " << mViewPoint << endl;
-
-	// take a render cost sample by rendering a cube
-	Vector3 directions[6];
-
-	directions[0] = Vector3(1,0,0);
-	directions[1] = Vector3(0,1,0);
-	directions[2] = Vector3(0,0,1);
-	directions[3] = Vector3(-1,0,0);
-	directions[4] = Vector3(0,-1,0);
-	directions[5] = Vector3(0,0,-1);
-
-	sample.mVisibleObjects = 0;
-
-	// reset object counters
-	ObjectContainer::const_iterator it, it_end = mObjects.end();
-
-	for (it = mObjects.begin(); it != it_end; ++ it) 
-	{
-		(*it)->mCounter = 0;
-	}
-
-	++ mFrame;
-
-	//glCullFace(GL_FRONT);
-	glCullFace(GL_BACK);
-	glDisable(GL_CULL_FACE);
-	
-
-	// query all 6 directions for a full point sample
-	for (int i = 0; i < 6; ++ i) 
-	{
-		mViewDirection = directions[i];
-		SetupCamera();
-
-		glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
-		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-		//glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);	glDepthMask(GL_TRUE);
-		glDepthFunc(GL_LESS);
-
-		mUseFalseColors = true;
-
-		// the actual scene rendering fills the depth (for occlusion queries)
-		// and the frame buffer (for item buffer)
-		RenderScene();
-
-
-		if (0) 
-		{
-			char filename[256];
-			sprintf(filename, "snap/frame-%04d-%d.png", mFrame, i);
-			QImage im = toImage();
-			im.save(filename, "PNG");
-		}
-         
-		// evaluate the sample
-		if (useOcclusionQueries) 
-		{
-			EvalQueryWithOcclusionQueries();
-		}
-		else 
-		{
-			EvalQueryWithItemBuffer();
-		}
-	}  
-
-	// now evaluate the statistics over that sample
-	// currently only the number of visible objects is taken into account
-	sample.Reset();
-
-	for (it = mObjects.begin(); it != it_end; ++ it) 
-	{
-		Intersectable *obj = *it;
-		if (obj->mCounter >= threshold) 
-		{
-			++ sample.mVisibleObjects;
-			sample.mVisiblePixels += obj->mCounter;
-		}
-	}
-
-	//cout << "RS=" << sample.mVisibleObjects << " ";
-}
-
-
-void
-GlRendererBuffer::SampleRenderCost(const int numSamples,
-								   vector<RenderCostSample> &samples,
-								   const bool useOcclusionQueries,
-								   const int threshold
-								   )
-{
-  makeCurrent();
-
-  if (mPixelBuffer == NULL)
-	  mPixelBuffer = new unsigned int[GetWidth()*GetHeight()];
-  
-  // using 90 degree projection to capture 360 view with 6 samples
-  SetupProjection(GetHeight(), GetHeight(), 90.0f);
-
-  //samples.resize(numSamples);
-  halton.Reset();
-  
-  // the number of queries queried in batch mode
-  const int numQ = 500;
-
-  //const int numQ = (int)mObjects.size();
-  if (useOcclusionQueries)
-  {
-	  cout << "\ngenerating " << numQ << " queries ... ";
-	  OcclusionQuery::GenQueries(mOcclusionQueries, numQ);
-	  cout << "finished" << endl;
-  }
-
-  // sampling queries 
-  for (int i = 0; i < numSamples; ++ i)
-  {
-	  cout << ".";
-	  EvalRenderCostSample(samples[i], useOcclusionQueries, threshold);
-  }
-
-  doneCurrent();
-
-}
-  
-
-void
 GlRendererBuffer::RandomViewPoint()
 { 
